import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Analise_Termica extends PApplet {

PGraphics Perfil;
PGraphics Diagrama;
PGraphics Animacao;
PGraphics Inicio;
PGraphics Grains;

PImage backgnd;
PImage p_curve;
PImage subtitles;

int activeScreen = 0;
int cgrain;

public void setup() {
  size(800, 600);
  backgnd = loadImage("back.jpg");
  
  // Imagens da tela inicial
  
  inicio = loadImage("textoinicio.png");
  subtitles = loadImage("sub.png");
  
  b_ani0 = loadImage("b_ani0.png");
  b_ani1 = loadImage("b_ani1.png");
  b_ani2 = loadImage("b_ani2.png");
  
  b_dia0 = loadImage("b_dia0.png");
  b_dia1 = loadImage("b_dia1.png");
  b_dia2 = loadImage("b_dia2.png");
  
  b_help0 = loadImage("b_help0.png");
  b_help1 = loadImage("b_help1.png");
  b_help2 = loadImage("b_help2.png");
  
  credits = loadImage("credits.png");
  
  b1 = loadImage("inicio_b1.png");
  b2 = loadImage("inicio_b2.png");
  
  // Imagens da parte do perfil
  
  p_curve = loadImage("curva.png");
  p_back = loadImage("p_back.png");
  
  b1_on = loadImage("b1_on.png");
  b1_off = loadImage("b1_off.png");
  b_temp = loadImage("b_temp.png");
  b_temp_on = loadImage("b_temp_on.png");
  
  b_reset0 = loadImage("b_reset0.png");
  b_reset1 = loadImage("b_reset1.png");
  b_reset2 = loadImage("b_reset2.png");
  
  t_ptoA = loadImage("ptoA.png");
  t_ptoB = loadImage("ptoB.png");
  t_liquidus = loadImage("liquidus.png");
  t_solidus = loadImage("solidus.png");
  
  verdana = loadFont("Verdana-12.vlw");
  
  // Imagens da animacao
  
  eixo = loadImage("eixo.png");
  tbox = loadImage("caixa1.png");
  tboxc = loadImage("caixac.png");
  balao = loadImage("balao_l.png");
  
  fwd = loadImage("fwd.png");
  bwd = loadImage("bwd.png");
  stp = loadImage("stp.png");
  
  for (int i = 0; i < exp_txt.length; i++)
    exp_txt[i] = loadImage("txt" + i + ".png");
  
  calibri = loadFont("Calibri-15.vlw");
  calibri10 = loadFont("Calibri-10.vlw");
  
  // Imagens do diagrama
  
  title = loadImage("title.png");
  
  diagrama = loadImage("diagrama.png");
  infobox = loadImage("info1.png");
  info_s = loadImage("info_s.png");
  
  drop = loadImage("drop.png");
  plus = loadImage("plus.png");
  adrop = loadImage("drop_active.png");
  sdrop = loadImage("drop_sel.png");
  aplus = loadImage("+_active.png");
  splus = loadImage("+_sel.png");
  xp = loadImage("xp.png");
  
  setad = loadImage("setad.png");
  setac = loadImage("setac.png");
  
  fade = loadImage("teste.png");
  pactive = loadImage("point_active.png");
  
  for (cgrain = 0; cgrain < grain.length; cgrain++)
    grain[cgrain] = loadImage("grain" + cgrain + ".png");
    
  cgrain = 0;
  
  me_screen = loadImage("canto1.png");
  me_mask = loadImage("me_mask.png");
  
  b_mod0 = loadImage("b_mod0.png");
  b_mod1 = loadImage("b_mod1.png");
  b_mod2 = loadImage("b_mod2.png");
  
  b_play0 = loadImage("b_play0.png");
  b_play1 = loadImage("b_play1.png");
  b_play2 = loadImage("b_play2.png");
  
  b_instruc0 = loadImage("b_instruc0.png");
  b_instruc1 = loadImage("b_instruc1.png");
  b_instruc2 = loadImage("b_instruc2.png");
  
  b_ti0 = loadImage("b_ti0.png");
  b_ti1 = loadImage("b_ti1.png");
  b_ti2 = loadImage("b_ti2.png");
  
    // Imagens da tela de ajuda
    
    scr_help = loadImage("scr_help.png");
  
  // Imagens da simula\u00e7\u00e3o
  
  text1 = loadImage("text1.png");
  text2 = loadImage("text2.png");
  text3 = loadImage("text3.png");
  text4 = loadImage("text4.png");
  text5 = loadImage("text5.png");
  box15 = loadImage("box15.png");
  
  goon0 = loadImage("goon0.png");
  goon1 = loadImage("goon1.png");
  
  // Novas imagens
  
  title_micro = loadImage("title_micro.png");
  
  // Graphics: completamente desnecess\u00e1rio [pra ESSE programa em particular]
  
  Perfil = createGraphics(800, 600, P2D);
  Diagrama = createGraphics(800, 600, P2D);
  Animacao = createGraphics(600, 400, P2D);
  Inicio = createGraphics(800, 600, P2D);
  
  smooth();
  noStroke();
}

public void draw() {
  switch(activeScreen) {
    case 0: drawInicio(); break;
    case 1: drawAnimacao(); break;
    case 2: drawDiagrama(); break;
    case 3: drawPerfil(); break;
    case 4: drawCredits(); break;
    case 5: drawHelp(); break;
  //  image(Perfil, 110, 50);
  }
}

public void mouseDragged() {
  
  // As somas aqui (195 e 160) \u00e9 do translate que nao sei por que nao funciona pra posicao do mouse
  
  if (activeScreen == 3) {
     if (mouseX >= 220+195 && mouseX <= 386+195 && mouseY >= 20+160 && mouseY <= 219+160) {
       if (opcao == 1)
         y1anchor = mouseY-160;
       if (opcao == 2)
         y2anchor = mouseY-160;
       if (opcao == 3) {
         if (mouseX >= 220+195 && mouseX <= 303+195 && mouseY >= 20+160 && mouseY <= 219+160) {
           a1 = 1;
           a2 = 0;
           if (mouseX < x1+195 && mouseY < y1+160) {
             x3 = mouseX-195;
             y3 = mouseY-160;
           }
         }
         if (mouseX > 303+195 && mouseX <= 386+195 && mouseY >= 20+160 && mouseY <= 219+160) {
           a1 = 0;
           a2 = 1;
           if (mouseX < x2+195 && mouseY < y2+160) {
             x4 = mouseX-195;
             y4 = mouseY-160;
           }
         }
       }
       if (opcao == 4) {
         if (mouseX >= 220+195 && mouseX <= 303+195 && mouseY >= 20+160 && mouseY <= 219+160) {
           a1 = 1;
           a2 = 0;
           if (mouseX > x3+195 && mouseY > y3+160) {
             x1 = mouseX-195;
             y1 = mouseY-160;
           }
         }
         if (mouseX > 303+195 && mouseX <= 386+195 && mouseY >= 20+160 && mouseY <= 219+160) {
           a1 = 0;
           a2 = 1;
           if (mouseX > x4+195 && mouseY > y4+160) {
             x2 = mouseX-195;
             y2 = mouseY-160;
           }
         }
       }
     }
  }
  
  if (activeScreen == 2) {
    if (mouseX >= 100 && mouseX <= 431 && mouseY >= 100 && mouseY < 497 && lock_axis == 0) {
      p[activePoint].px = mouseX - 100;
      p[activePoint].py = mouseY - 100;
      alavanca();
    }
    
    // Controle dos pontos pelos eixos
    // Composicao
    
    if (mouseX >= 100 && mouseX <= 431 && mouseY >= 497 && mouseY <= 508) {
      lock_axis = 1;
      p[activePoint].px = mouseX - 100;
      alavanca();
    }
      
    // Temperatura  
    
    if (mouseX >= 89 && mouseX <= 100 && mouseY >= 100 && mouseY <= 497) {
      lock_axis = 1;
      p[activePoint].py = mouseY - 100;
      alavanca();
    }
  }
}

public void mousePressed() {
  
  if (activeScreen == 4)
    if (mouseX > 673 && mouseX < 695 && mouseY > 55 && mouseY < 73)
      activeScreen = 0;
  
  if (activeScreen == 5)
    if (mouseX > 694 && mouseX < 716 && mouseY > 53 && mouseY < 71)
      activeScreen = 2;
  
  if (activeScreen == 0) {
    if (mouseX > 198 && mouseX < 324 && mouseY > 300 && mouseY < 337) {
     image(b_ani2, 199, 301);
     activeScreen = 1;
    }
     
     if (mouseX > 479 && mouseX < 605 && mouseY > 300 && mouseY < 337) {
       image(b_dia2, 479, 300);
       activeScreen = 2;
     }
     
     if (mouseX > 670 && mouseX < 795 && mouseY > 5 && mouseY < 41) {
       image(b_help2, 670, 5);
       activeScreen = 4;
     }
  }
  
  if (activeScreen == 1) {
    
      // Botao voltar
    
      if (mouseX > 640 && mouseX <= 654 && mouseY >= 97 && mouseY <= 116)
        back_ani();
      
      
      // Reset
      
      if (mouseX > 610 && mouseX <= 625 && mouseY >= 97 && mouseY <= 116 && trigger == 5) {
        reset();
      }
        
      // Botao de avan\u00e7ar
      
      if (mouseX > 670 && mouseX <= 684 && mouseY >= 97 && mouseY <= 116)
          forw_ani();
  
      if (mouseX > 640 && mouseX <= 661 && mouseY >= 102 && mouseY <= 119 && trigger == 5)
        trigger = 6;
      
      if (mouseX > 10 && mouseX < 110 && mouseY > 10 && mouseY < 40) {
        image(b_ti2, 10, 10);
        reset();
        activeScreen = 0;
      }
  }
  
  if (activeScreen == 2) {
    
    // Botao pra modificar a curva
    
    if (mouseX > 100 && mouseX < 168 && mouseY > 525 && mouseY < 553) {
      activeScreen = 3;
      image(b_mod2, 100, 525);
    }
    
    // Bot\u00e3o das instru\u00e7\u00f5es
    
    if (mouseX > 690 && mouseX < 790 && mouseY > 10 && mouseY < 40) {
      image(b_instruc2, 690, 10);
      activeScreen = 5;
    }
    
    if (mouseX > 10 && mouseX < 110 && mouseY > 10 && mouseY < 40) {
      image(b_ti2, 10, 10);
      activeScreen = 0;
    }
    
    // Botao de play da anima\u00e7\u00e3o de resfriamento
    
    if (mouseX > textWidth("Explica\u00e7\u00e3o:") + 560 && mouseX < textWidth("Explica\u00e7\u00e3o:") + 589 && mouseY > 528 && mouseY < 551) {
      image(b_play2, textWidth("Explica\u00e7\u00e3o:") + 560, 528);
      py_temp = p[activePoint].py;
      p[activePoint].py = 0;
      simulacao = 1;
      iframe = 1;
    }
    
    // Sai da tela de escolha de pontos
    
    if (dropb == 1 && mouseX >= 550 && mouseX <= 721 && mouseY >= 267 && mouseY <= (267 + nPoint*27)) {
      if (mouseX >= 660 && mouseX <= 672 && mouseY >= 267 && mouseY <= (267 + nPoint*27)) {
        activePoint = PApplet.parseInt((mouseY - 240)/27) - 2;
        for (i = PApplet.parseInt((mouseY - 240)/27) - 1; i < 4; i++)
          p[i] = p[i+1];
        nPoint--;
      }
      else
        activePoint = PApplet.parseInt((mouseY - 240)/27) - 1;
      dropb = 0;
    }
    
    if (dropb == 1 && !(mouseX >= 550 && mouseX <= 721 && mouseY >= 267 && mouseY <= (267 + nPoint*27)))  
      dropb = 0;
    
    // Vai pra tela de escolha de pontos
    
    if (mouseX > 550 && mouseX < 684 && mouseY > 240 && mouseY < 267)
      dropb = 1;
      
    // Adiciona um novo ponto e define ele como ponto ativo
    
    if (mouseX > 697 && mouseX < 720 && mouseY > 240 && mouseY < 267 && nPoint < 5) {
      image(aplus, 550, 240);
      nPoint++;
      p[nPoint - 1] = new Pontos(0, 397, 0, 0);
      activePoint = nPoint - 1;
    }
    
    // Entrada de valores pras informa\u00e7\u00f5es
    
    if (mouseX > 550 && mouseX < 721 && mouseY > 322.5f+15 && mouseY < 337.5f+15)
      info_in = 1;
    if (mouseX > 550 && mouseX < 721 && mouseY > 337.5f+15 && mouseY < 352.5f+15)
      info_in = 2;
    if (mouseX > 550 && mouseX < 721 && mouseY > 352.5f+20 && mouseY < 367.5f+20)
      info_in = 3;
    
    if (mouseX > 550 && mouseX < 721 && mouseY > 430 && mouseY < 445)
      info_in = 4;
    if (mouseX > 550 && mouseX < 721 && mouseY > 445 && mouseY < 460)
      info_in = 5;
  }
  
  if (activeScreen == 3) {
    if (dist(mouseX, mouseY, 221, 216) <= 8)
      opcao = 1;
    if (dist(mouseX, mouseY, 221, 236) <= 8)
      opcao = 2;
    if (dist(mouseX, mouseY, 221, 256) <= 8)
      opcao = 3;
    if (dist(mouseX, mouseY, 221, 276) <= 8)
      opcao = 4;
    
    // Botao de reset
    
    if (mouseX > 216 && mouseX <= 287 && mouseY >= 311 && mouseY <= 333) {
      image(b_reset2, 215, 310);
      y1anchor = 190;
      y2anchor = 70;
      x1 = 285; y1 = 155;
      x2 = 330; y2 = 130;
      x3 = 260; y3 = 110;
      x4 = 320; y4 = 85;
      temp1 = 1000;
      temp2 = 1600;
      tempm = 100;
    }
    
    // Botoes pra mudar os valores das temperaturas na escala
    
    if (mouseX > 187+195 && mouseX < 217+195 && mouseY > 213+160 && mouseY < 226+160)
      temp_input = 1;
    if (mouseX > 187+195 && mouseX < 217+195 && mouseY > 14+160 && mouseY < 27+160)
      temp_input = 2;
      
    if (mouseX > 581 && mouseX < 603 && mouseY > 154 && mouseY < 172)
      activeScreen = 2;
  }
  
  // Botoes de continua\u00e7\u00e3o da explica\u00e7\u00e3o
  
  if (activeScreen == 2 && simulacao == 1) {
    switch (iframe) {
      case 1: if (mouseX >= p[activePoint].px + text1.width - goon0.width + 223 && mouseX <= p[activePoint].px + text1.width + 100 && mouseY >= p[activePoint].py + text1.height - goon0.height + 100 && mouseY <= p[activePoint].py + text1.height + 100)
        iframe++; break;
      case 3: if (mouseX >= p[activePoint].px + text2.width - goon0.width + 223 && mouseX <= p[activePoint].px + text2.width + 100 && mouseY >= p[activePoint].py + text2.height - goon0.height + 100 && mouseY <= p[activePoint].py + text2.height + 100)
        iframe++; break;
      case 4: if (state == 2 && mouseX >= p[activePoint].px + text3.width - goon0.width + 223 && mouseX <= p[activePoint].px + text3.width + 100 && mouseY >= p[activePoint].py + text3.height - goon0.height + 100 && mouseY <= p[activePoint].py + text3.height + 100)
        iframe++; break;
      case 6: if (mouseX >= p[activePoint].px + text4.width - goon0.width + 223 && mouseX <= p[activePoint].px + text4.width + 100 && mouseY >= p[activePoint].py + text4.height - goon0.height + 100 && mouseY <= p[activePoint].py + text4.height + 100)
        iframe++; break;
      case 7: if (mouseX >= p[activePoint].px + text5.width - goon0.width + 223 && mouseX <= p[activePoint].px + text5.width + 100 && mouseY >= p[activePoint].py + text5.height - goon0.height + 100 && mouseY <= p[activePoint].py + text5.height + 100)
        iframe++; break;
    }
  }
  
}

public void mouseReleased() {
  if (a1 == 1)
    a1 = 0;
  if (a2 == 1)
    a2 = 0;
    
  if (lock_axis == 1)
    lock_axis = 0;
}

public void keyPressed() {
  
  if (activeScreen == 3) {
    if (temp_input == 1 || temp_input == 2) {
      if (key >= '0' && key <= '9'){
        input += PApplet.parseChar(key);
        if (abs(PApplet.parseInt(input)) > 10000 || abs(PApplet.parseInt(input)) < 0){
          input = input.substring(0, input.length()-1 ); 
        }
      }
      else if( key == BACKSPACE && input.length() > 0 )
        input = input.substring(  0, input.length()-1 );
      else if (key == RETURN || key == ENTER) {
        if (temp_input == 1 && PApplet.parseInt(input) < temp2)
          temp1 = PApplet.parseInt(input);
        if (temp_input == 2 && PApplet.parseInt(input) > temp1)
          temp2 = PApplet.parseInt(input);
        temp_input = 0;
        input = "";
        tempm = (temp2 - temp1)/6;
      }
    }
  }
  
  if (activeScreen == 2) {
      if (info_in != 3 && info_in != 0) {
        if (key >= '0' && key <= '9') {
          input += PApplet.parseChar(key);
          if (abs(PApplet.parseInt(input)) > 100 || abs(PApplet.parseInt(input)) < 0)
            input = input.substring(0, input.length()-1 ); 
        }
        else if( key == BACKSPACE && input.length() > 0 )
          input = input.substring(  0, input.length()-1 );
        else if (key == RETURN || key == ENTER) {
          switch(info_in) {
            case 1: p[activePoint].pc = 100 - PApplet.parseFloat(input);
                    p[activePoint].px = 331*p[activePoint].pc/100;
                    info_in = 0;
                    input = "";
                    break;
            case 2: p[activePoint].pc = PApplet.parseFloat(input);
                    p[activePoint].px = 331*p[activePoint].pc/100;
                    info_in = 0;
                    input = "";
                    break;
            case 4: wl = PApplet.parseFloat(input)/100;
                    p[activePoint].px = -wl*(x_bezier2 - x_bezier) + x_bezier2;
                    info_in = 0;
                    input = "";
                    break;
            case 5: wl = 1 - PApplet.parseFloat(input)/100;
                    p[activePoint].px = -wl*(x_bezier2 - x_bezier) + x_bezier2;
                    info_in = 0;
                    input = "";
                    break;
          }
        }
      }
      
      else {
        if (key >= '0' && key <= '9') {
          input += PApplet.parseChar(key);
          if (abs(PApplet.parseInt(input)) > temp2)
            input = input.substring(0, input.length()-1 );
        }
        else if( key == BACKSPACE && input.length() > 0 )
          input = input.substring(  0, input.length()-1 );
        else if (key == RETURN || key == ENTER) {
          if (abs(PApplet.parseInt(input)) < PApplet.parseInt(temp1) || abs(PApplet.parseInt(input)) > PApplet.parseInt(temp2)) {
            info_in = 0;
            input = "";
          }
          else {
            p[activePoint].pt = PApplet.parseFloat(input);
            p[activePoint].py = (p[activePoint].pt - temp2)*(-397)/(temp2 - temp1);
            info_in = 0;
            input = "";
          }
        }
      }
      
//                                            if (key == CODED) {
//                                              if (keyCode == RIGHT)
//                                                cgrain++;
//                                              if (keyCode == LEFT)
//                                                cgrain--;
//                                            }
// S\u00f3 liberar quando quiser posicionar os gr\u00e3os
  }
  
  if (key == CODED) {
    if (activeScreen == 2 && keyCode == KeyEvent.VK_F1)
      activeScreen = 5;
  }
}

public void reset() {
   for (i = 0; i < 11; i++) {
              x0[i] = x02[i];
              xf[i] = xf2[i];
              yf[i] = yf2[i];
              x2i[i] = x2i2[i];
              x2f[i] = x2f2[i];
              y2i[i] = y2i2[i];
            }
            for (i = 0; i < 9; i++)
              for (j = 0; j < 8; j++)
                curvas[i][j] = curvas2[i][j];
            y0 = y02;
            eixo_x = 432;
            pts = 0;
            
        cor = 0;
        timer = 0;
        
        for (i = 1; i < 9; i++)
                ani[i] = 0;
        
        timer_curvas = 0;
        fim = 0;
        
        trigger = 0; 
}
float timer = 0;
float offset = 0.3f;
int trigger = 0;
int i, j;
int v = 0;
int pts = 0;
int cor = 0;
float alfa = 0;
float eixo_x = 432;

int timer_curvas = 0;
float x_aux = 52, y_aux = 37;
float x_aux2 = 65, y_aux2;
float[] ani = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
int fim = 0;

PImage eixo;
PImage tbox;
PImage tboxc;
PImage balao;
PImage fwd, bwd, stp;

PImage[] exp_txt = new PImage[15];

PFont calibri;
PFont calibri10;

  float[] x0 = { 40, 60, 80, 100, 120, 140, 160, 180, 200, 224, 240 };
  float y0 = 40;
  float[] xf = { 70, 84, 100, 115, 132, 149, 166, 184, 202, 221.5f, 241 };
  float[] yf = { 160, 138, 120, 104, 89, 76, 65, 56, 50, 46, 42 };
  float[] x2i = { 80, 100, 123, 140, 162, 177, 196, 207, 218, 234, 252 };
  float[] x2f = { 95, 115, 140, 160, 185, 203, 225, 240, 255, 275, 295 };
  float[] y2i = { 160, 156, 149, 139, 128, 115, 102, 88, 74, 59, 44 };
  float[][] curvas = {  {84, 138, 90, 139, 97, 148, 100, 156}, {100, 120, 106, 121, 116, 125, 123, 149}, 
                      {115, 104, 121, 104, 136, 116, 140, 139}, {132, 89, 144, 89, 158, 105, 162, 128}, {149, 76, 157, 78, 171, 88, 177, 115},
                      {166, 65, 172, 67, 186, 67, 196, 102}, {184, 56, 190, 58, 200, 60, 207, 88}, {202, 50, 208, 50, 214, 54, 218, 74}, {221.5f, 46, 225, 45, 231, 44, 234, 59} };
                      
  float[] x02 = { 40, 60, 80, 100, 120, 140, 160, 180, 200, 224, 240 };
  float y02 = 40;
  float[] xf2 = { 70, 84, 100, 115, 132, 149, 166, 184, 202, 221.5f, 241 };
  float[] yf2 = { 160, 138, 120, 104, 89, 76, 65, 56, 50, 46, 42 };
  float[] x2i2 = { 80, 100, 123, 140, 162, 177, 196, 207, 218, 234, 252 };
  float[] x2f2 = { 95, 115, 140, 160, 185, 203, 225, 240, 255, 275, 295 };
  float[] y2i2 = { 160, 156, 149, 139, 128, 115, 102, 88, 74, 59, 44 };
  float[][] curvas2 = {  {84, 138, 90, 139, 97, 148, 100, 156}, {100, 120, 106, 121, 116, 125, 123, 149}, 
                      {115, 104, 121, 104, 136, 116, 140, 139}, {132, 89, 144, 89, 158, 105, 162, 128}, {149, 76, 157, 78, 171, 88, 177, 115},
                      {166, 65, 172, 67, 186, 67, 196, 102}, {184, 56, 190, 58, 200, 60, 207, 88}, {202, 50, 208, 50, 214, 54, 218, 74}, {221.5f, 46, 225, 45, 231, 44, 234, 59} };

public void drawAnimacao() {
  
  // Controladores do tempo. A cada frame add 1/frameRate ao timer
  // de forma que 1 segundo passa depois do n. de frames determinado
  
  background(backgnd);
  
  // Explicacao
  
  fill(100);
  textFont(verdana);
  textSize(10);
  
  image(tbox, 135, 30, 552, 90);
  
  if (trigger == 0)
    text("Clique na seta (>) para avan\u00e7ar na anima\u00e7\u00e3o ou na seta (<) para voltar.", 150, 40, 525, 70);
  
  if (trigger == 1)
    text("Uma curva de resfriamento representa a temperatura em fun\u00e7\u00e3o do tempo durante o processo de solidifica\u00e7\u00e3o de uma dada amostra. Curvas dessa natureza permitem a an\u00e1lise t\u00e9rmica do processo de solidifica\u00e7\u00e3o.", 150, 40, 525, 70);
  
  if (trigger == 11) {
    image(exp_txt[0], 135, 30);
  }
  if (trigger == 21) {
    image(exp_txt[1], 135, 30);
  }
  
  if (trigger == 31) {
    image(exp_txt[2], 135, 30);
  }
   
  if (trigger == 41) {
    image(exp_txt[3], 135, 30);
    timer_curvas = 4;
    if (fim == 0) {
      x_aux = 52; y_aux = 37;
      x_aux2 = 65;
    }
  }
  
  if (trigger == 51) {
    text("\u00c9 ilustrado o mesmo processo para as demais curvas. A \u00faltima curva representa, assim como a primeira, um metal puro, por\u00e9m com 100% de B. Condizentemente, a solidifica\u00e7\u00e3o aqui tamb\u00e9m ocorre a temperatura constante.", 150, 40, 525, 80);
      x_aux = 72; y_aux = 37;
      x_aux2 = 260;
  }
  
  println(trigger);
  
  if (trigger == 2) {
    text("A regi\u00e3o vermelha das curvas indica que o material se encontra integralmente no estado l\u00edquido, a regi\u00e3o verde indica que as fases s\u00f3lida e l\u00edquida do material coexistem e, finalmente, a regi\u00e3o azul indica que o material se encontra integralmente no estado s\u00f3lido.", 150, 40, 525, 70);
    timer += 1/frameRate;
  }
  
  if (trigger == 3)
    text("Agora ser\u00e1 removida a depend\u00eancia temporal das curvas. Isso significa que todas as curvas ficar\u00e3o paralelas ao eixo das temperaturas, sendo caracterizadas, para cada composi\u00e7\u00e3o, por suas temperaturas l\u00edquidus e solidus.", 150, 40, 525, 70);
    
  if (trigger == 4) {
    image(exp_txt[4], 135, 30);
    
  }
  
  if (trigger == 5) {
    image(exp_txt[14], 135, 30);
    
  }
 
  if (trigger > 0)
    image(bwd, 640, 97);
  
  if (trigger <= 6 || trigger > 10)
    image(fwd, 670, 97);
  
  pushMatrix();
  
  image(b_ti0, 10, 10);
  if (mouseX > 10 && mouseX < 110 && mouseY > 10 && mouseY < 40)
    image(b_ti1, 10, 10);
  
  translate(200, 180);
  
  // Eixo do tempo/composi\u00e7\u00e3o
  
  image(eixo, 32, 0, eixo_x, 342);
  if (trigger == 4 && eixo_x > 350)
    eixo_x -= 4*offset;
  
  textFont(verdana);
  fill(0);
  
  if (trigger != 4 && trigger != 5)
    image(exp_txt[6], 110, -20);
//    text("Gr\u00e1fico 1: Temperatura x Tempo", 235, -5);
  
  text("Temperatura", -3, 35);
  
  if (trigger < 4 || trigger > 10)
    text("Tempo", 430, 350);
  
  noFill();
  
  translate(-13, 0);
  
  // Composi\u00e7\u00f5es
  
  if (trigger > 1 && trigger < 4 || trigger >= 21) {
      for (i = 60; i <= 360; i += 30) {
        if (i == 60)
          text(0, 50, 50);
        else
          text((i-60)/3, i, 50);
      }
    text("Composi\u00e7\u00e3o (%B)", 210, 30);
  }
  
  if (trigger >= 4 && xf[10] >= x2i[10] && xf[0] >= x2i[0]) {
    for (i = 60; i <= 360; i += 30)
      text((i-60)/3, i, 350);
    text("Composi\u00e7\u00e3o (%B)", 210, 370);
    text("A Puro", 20, 350);
    text("B Puro", 400, 350);
    if (y0 > 10)
      y0 -= offset;
  }
  
  // Mudan\u00e7a de cores do diagrama
  
  strokeWeight(1.5f);
  stroke(255, 0, 0);
  if (trigger >= 4 && pts > 9)// || (trigger == 2 && cor != 1 && cor != 0))
    stroke(150);
    
  scale(1.5f);
  
        // Desenho das curvas (retas de cima)
        
        if (trigger >= 2 && trigger <= 5 || trigger == 51) {
          for (i = 40; i <= 240; i += 20) {
            if (i == 220)
              i = 221;
            line(i, y0, xf[v], yf[v]);
            if (i == 221)
              i = 220;
            v++;
          }
        }
        
        // Desenho da primeira curva de resfriamento (metal puro)
        
        if (trigger == 31 && timer_curvas == 0) {
          
          line(40, y0, 40 + alfa*(xf[0]-40), y0 + alfa*(yf[0]-y0));
          alfa += 0.03f;
          
          if (alfa >= 1.0f) {
            timer_curvas = 1;
            alfa = 0.0f;
          }
        }        
          
  // Tira o eixo do tempo (1)
  
  if (trigger == 4) {
    for (i = 0; i < 11 && xf[i] > x0[i]+0.5f; i++)
        xf[i] -= offset;
  }
  v = 0;
  
  // Mudan\u00e7a de cores do diagrama
  
  stroke(0, 0, 255);
  if (trigger >= 4 && pts > 9) {  //|| (trigger == 2 && cor != 3 && cor != 0))
    stroke(150);
    pushMatrix();
    resetMatrix();
      image(exp_txt[5], 230, 159);
    popMatrix();
  }
  
  if (trigger == 4) {
    for (i = 0; i < 11; i++) {
      if (x2i[i] > xf[i])
        x2i[i] -= offset;   
      if (x2f[i] > x2i[i]+1)
        x2f[i] -= (x2f[i]-x2i[i])*offset;
    }
  }
  
          // Desenho das curvas (retas de baixo)
          
          if (trigger >= 2 && trigger <= 5 || trigger == 51)
            for (i = 0; i < 11; i++)
              line(x2i[i], y2i[i], x2f[i], 220);
              
          if (timer_curvas == 2) {
              stroke(255, 0, 0);
            line(40, y0, xf[0], yf[0]);
            
              stroke(0, 255, 0);
            line(xf[0], 160, x2i[0], 160);
            
              stroke(0, 0, 255);
            line(x2i[0], y2i[0], x2i[0] + alfa*(x2f[0] - x2i[0]), y2i[0] + alfa*(220 - y2i[0]));
            alfa += 0.03f;
            
            if (alfa >= 1.0f) {
              timer_curvas = 3;
              alfa = 0.0f;
            }
          } 
  
  // Mudan\u00e7a de cores do diagrama
    stroke(0, 255, 0);
  if ((trigger >= 4 && pts > 9))
    stroke(0);
//  if (trigger == 2 && cor != 2 && cor != 0)
//    stroke(150);
  
          // Desenho das curvas (bezier)
          
          if (trigger >= 2 && trigger <= 5 || trigger == 51)
            for (i = 0; i < 9; i++)
                bezier(curvas[i][0], curvas[i][1], curvas[i][2], curvas[i][3], curvas[i][4], curvas[i][5], curvas[i][6], curvas[i][7]);
  
          // Desenho das curvas (retas do meio)
          
          if (trigger >= 2 && trigger <= 5 || trigger == 51) {
            line(xf[0], 160, x2i[0], 160);
            line(xf[10], 44, x2i[10], 44);
          }
          
          if (timer_curvas == 1) {
              stroke(255, 0, 0);
            line(40, y0, xf[0], yf[0]);
            
              stroke(0, 255, 0);
            line(xf[0], 160, xf[0] + alfa*(x2i[0] - xf[0]), 160);
            alfa += 0.08f;
            
            if (alfa >= 1.0f) {
              timer_curvas = 2;
              alfa = 0.0f;
            }
          }
  
  if (trigger == 4) {
    for (i = 1; i < 10; i++) {
      if (curvas[i-1][0] > xf[i])
        curvas[i-1][0] -= offset;
      if (curvas[i-1][6] > x2i[i])
        curvas[i-1][6] -= offset;
      if (curvas[i-1][2] > x2i[i])
        curvas[i-1][2] -= offset;
      if (curvas[i-1][4] > x2i[i])
        curvas[i-1][4] -= offset;
      curvas[i-1][3] = curvas[i-1][5] = (yf[i] + y2i[i])/2;
    }
  }
  
  
  // Baloes de explicacao
  
  if (trigger >= 4 && xf[10] >= x2i[10] && xf[0] >= x2i[0]) {
    stroke(0);
    strokeWeight(1);
    
    // Desenho da linha liquidus; 'pts' \u00e9 o contador das curvas
    // A cada frame desenha uma parte da reta at\u00e9 o ponto seguinte
    // Quando chega no ponto seguinte, o alfa \u00e9 zerado, aumenta-se 'pts' e deixa
    // permanente a reta que foram criadas at\u00e9 o pts atual (o ultimo 'for')
    // Quando o alfa chega em 1, eu sei que a reta chegou no ponto final:
    // xf = x0 + alfa*(xf - x0)
    // yf = y0 + alfa*(yf - y0)    
    
    if (pts < 9) {
        line(xf[pts], yf[pts], xf[pts] + alfa*(xf[pts+1]-xf[pts]), yf[pts] + alfa*(yf[pts+1]-yf[pts]));
        alfa += 0.05f;
    }
    
    if (pts == 9) {
      line(xf[pts], yf[pts], xf[pts] + alfa*(x2i[pts+1]-xf[pts]), yf[pts] + alfa*(y2i[pts+1]-yf[pts]));
      alfa += 0.01f;
    }
    
    if (alfa >= 1.0f) {
      alfa = 0.0f;
      pts++;
    }
    
    // Desenho das linhas depois de tra\u00e7adas
    
    // Mudan\u00e7a de cores do diagrama
    
    if (trigger >= 4 && pts > 9)
      stroke(255, 0, 0);
    
    for (i = 0; i < pts; i++) {
      if (i >= 9)
        line(xf[9], yf[9], x2i[10], y2i[10]);
      else
        line(xf[i], yf[i], xf[i+1], yf[i+1]);
    }
    
    // Desenho da linha solidus;
    
    if (pts < 10) {
        line(x2i[pts], y2i[pts], x2i[pts] + alfa*(x2i[pts+1]-x2i[pts]), y2i[pts] + alfa*(y2i[pts+1]-y2i[pts]));
        alfa += 0.01f;
    }
    
    if (alfa >= 1.0f) {
      alfa = 0.0f;
      pts++;
    }
    
    // Mudan\u00e7a de cores do diagrama
    
    if (trigger >= 4 && pts > 9)
      stroke(0, 0, 255);
    
    for (i = 0; i < pts; i++)
        line(x2i[i], y2i[i], x2i[i+1], y2i[i+1]);
  }
  
  // Anima\u00e7\u00e3o da segunda curva de resfriamento
  
  if (timer_curvas >= 3 && trigger < 51 && trigger > 10) {
      stroke(255, 0, 0);
    line(40, y0, xf[0], yf[0]);
    line(60, y0, xf[1], yf[1]);
    
      stroke(0, 255, 0);
    line(xf[0], 160, x2i[0], 160);
    bezier(curvas[0][0], curvas[0][1], curvas[0][2], curvas[0][3], curvas[0][4], curvas[0][5], curvas[0][6], curvas[0][7]);
    
      stroke(0, 0, 255);
    line(x2i[0], y2i[0], x2f[0], 220);
    line(x2i[1], y2i[1], x2f[1], 220);
    
      pushStyle();
        
        fill(255);
        noStroke();
        
        if (timer_curvas <= 3)
          quad(x_aux, y_aux, x_aux2 + 2, y_aux, 122, 221, 107, 221);
        
        if (timer_curvas == 4 && fim == 0) {
        
          if (alfa < 1.0f) {
            quad(x_aux + alfa*(107 - x_aux), y_aux + alfa*(221 - y_aux), x_aux2 + 2 + alfa*(122 - x_aux), y_aux + alfa*(221 - y_aux), 122, 221, 107, 221);
            alfa += 0.01f;
          }
          else {
            alfa = 0;
            timer_curvas = 5;
            fim = 1;
          }
        }
        
        fill(0);
        
      popStyle();
    
    // Texto da temp. de fus\u00e3o
    
    if (timer_curvas == 3) {
      pushMatrix();
      
      pushStyle();
      
      stroke(0);
      strokeWeight(0.5f);
      fill(0);
      line(-10, 160, 65, 160);
      ellipse(-10, 160, 2, 2);
      
      resetMatrix();
        image(exp_txt[8], 150, 400);
      
      popStyle();
      popMatrix();
    }

    if (fim == 1 && trigger == 41) {
      pushMatrix();
      
      pushStyle();
      
      stroke(0);
      strokeWeight(0.5f);
      
      fill(0);
      line(-10, 138, 80, 138);
      ellipse(-10, 138, 2, 2);
      line(-10, 156, 96, 156);
      ellipse(-10, 156, 2, 2);
      
      resetMatrix();
        image(exp_txt[7], 120, 380);
        
      popStyle();
      
      popMatrix();
    }
    
  }
  
  // Anima\u00e7\u00e3o das demais curvas
  
  if (trigger == 51) {
    
    pushStyle();
        
    fill(255);
    noStroke();
    
    for (i = 1; i < 9; i++) {
      
      if (ani[0] < 1.0f) {
        quad(72 + ani[0]*(132 - 72), 37 + ani[0]*(221 - 37), 90 + ani[0]*(145 - 88),  37 + ani[0]*(221 - 37), 145, 221, 132, 221);
        ani[0] += 0.002f;
      }
      
      if (ani[i] < 1.0f) {
        quad(92 + ani[1]*(152 - 92), 37 + ani[1]*(219 - 37), 113 + ani[1]*(165 - 113),  37 + ani[1]*(219 - 37), 165, 221, 152, 221);
        quad(114 + ani[2]*(172 - 114), 37 + ani[2]*(219 - 37), 139 + ani[2]*(190 - 139),  37 + ani[2]*(219 - 37), 190, 221, 172, 221);
        quad(136 + ani[3]*(192 - 136), 37 + ani[3]*(219 - 37), 159 + ani[3]*(208 - 159),  37 + ani[3]*(219 - 37), 208, 221, 192, 221);
        quad(156 + ani[4]*(212 - 156), 37 + ani[4]*(219 - 37), 179 + ani[4]*(230 - 179),  37 + ani[4]*(219 - 37), 230, 221, 212, 221);
        quad(178 + ani[5]*(232 - 177), 37 + ani[5]*(219 - 37), 199 + ani[5]*(245 - 199),  37 + ani[5]*(219 - 37), 245, 221, 232, 221);
        quad(192 + ani[6]*(252 - 192), 37 + ani[6]*(219 - 37), 219 + ani[6]*(260 - 219),  37 + ani[6]*(219 - 37), 260, 221, 252, 221);
        quad(212 + ani[7]*(272 - 212), 37 + ani[7]*(219 - 37), 233 + ani[7]*(280 - 233),  37 + ani[7]*(219 - 37), 280, 221, 272, 221);
        quad(232 + ani[8]*(292 - 232), 37 + ani[8]*(219 - 37), 253 + ani[8]*(300 - 253),  37 + ani[8]*(219 - 37), 300, 221, 292, 221);
        if (ani[i-1] > 0.2f && i > 0)
          ani[i] += 0.01f;
      }
    }
    
    popStyle();
  }
  
  
  popMatrix();
  
  pushMatrix();
  
    translate(200, 180);
    textFont(verdana);
    fill(0);
    
    if (trigger == 2) {
      if (timer > 2) {
//          image(tboxc, 80, 90, 80, 18);
//          text("Liquido", 80, 90, 80, 18);
          image(exp_txt[9], 80, 90);
          cor = 1;
      }
      if (timer > 4) {
//          image(tboxc, 170, 160, 98, 18);
//          text("Solido+Liquido", 170, 160, 98, 18);
          image(exp_txt[10], 160, 160);
          cor = 2;
      }
      if (timer > 6) {
//          image(tboxc, 280, 270, 80, 18);
//          text("Solido", 280, 270, 80, 18);
          image(exp_txt[11], 260, 240);
          cor = 3;
      }
    }
    
    if (trigger >= 4 && pts > 9) {
//      image(tboxc, 85, 95, 98, 18);
//      text("Linha Liquidus", 85, 95, 98, 18);
//      image(tboxc, 230, 210, 98, 18);
//      text("Linha Solidus", 230, 210, 98, 18);
        image(exp_txt[12], 85, 95);
        image(exp_txt[13], 210, 185);
    }
  
  popMatrix();
  println(eixo_x);
}

public void back_ani() {
  switch(trigger) {
    case 0: trigger = 0; break;
    
    case 1: trigger--; break;
    
    case 11: trigger = 1; break;
    
    case 21: trigger -= 10; break;
    
    case 31: trigger -= 10;
              timer_curvas = 0; break;
              
    case 41: trigger -= 10;
              fim = 0;
              timer_curvas = 0; break;
              
    case 51: trigger -= 10; break;
    
    case 2: trigger = 51;
            for (i = 1; i < 9; i++)
                ani[i] = 0;  break;
                
    case 3: trigger--;
              timer = 0;
              cor = 0; break;
              
    case 4: trigger--;
            for (i = 0; i < 11; i++) {
              x0[i] = x02[i];
              xf[i] = xf2[i];
              yf[i] = yf2[i];
              x2i[i] = x2i2[i];
              x2f[i] = x2f2[i];
              y2i[i] = y2i2[i];
            }
            for (i = 0; i < 9; i++)
              for (j = 0; j < 8; j++)
                curvas[i][j] = curvas2[i][j];
            y0 = y02;
            eixo_x = 432;
            pts = 0;
            break;
            
     case 5: trigger--; break;
  }
}

public void forw_ani() {
  switch(trigger) {
    case 0: trigger++; break;
    
    case 1: trigger = 11; break;
    
    case 11: trigger += 10; break;
    
    case 21: trigger += 10; break;
    
    case 31: trigger += 10; 
              timer_curvas = 0; break;
              
    case 41: trigger += 10;
              fim = 0;
              for (i = 0; i < 9; i++)
                ani[i] = 0;  break;
                
    case 51: trigger = 2;
              timer = 0;
              cor = 0; break;
              
    case 2: trigger++; break;
    
    case 3: trigger++;
             break;
            
    case 4: trigger++; break;
    
    case 5: activeScreen = 2; reset(); break;
  }
}
PImage title;

PImage diagrama;
PImage infobox;
PImage info_s;

PImage drop;
PImage plus;
PImage adrop;
PImage sdrop;
PImage aplus;
PImage splus;

PImage setad;
PImage setac;

PImage b_mod0;
PImage b_mod1;
PImage b_mod2;

PImage b_play0;
PImage b_play1;
PImage b_play2;

PImage b_instruc0;
PImage b_instruc1;
PImage b_instruc2;

PImage b_ti0;
PImage b_ti1;
PImage b_ti2;

int dropb = 0;
int lock_axis;
float x_bezier, y_bezier;
float x_bezier2, y_bezier2;

int simulacao = 0;

PImage scr_help;

// 1: %A , 2: %B , 3: T , 4: Wl , 5: Walpha

int info_in = 0;

// Variaveis dos pontos

int activePoint = -1;
int nPoint = 1;
Pontos[] p = new Pontos[5];
float r, s;
float wl, walpha;

float t;
float EPS = 0.01f;

// 1: liquido, 2: solido + liquido, 4: solido

int state = 0;

float magic = 1.993975903f;

PImage title_micro;

public void drawDiagrama() {
  
  Diagrama.beginDraw();
  
  background(backgnd);
  image(diagrama, 100, 100);

  grains();
  
  // Redesenha a o diagrama numa propor\u00e7\u00e3o maior. A proporcao
  // (magic) eu achei dividindo as dimensoes do diagrama maior
  // pelas do menor
  
  pushMatrix();
  
  noFill();
  stroke(255, 0, 0);
  translate(100, 100);
  
  // Condicao inicial
  
  if (activePoint == -1) {
    p[0] = new Pontos(0, 100, 0, 0); // 397
    activePoint = 0;
  }
  
  bezier(0, (y1anchor-20)*magic, (x3-220)*magic, (y3-20)*magic, (x4-220)*magic, (y4-20)*magic, 330, (y2anchor-20)*magic);
  bezier(0, (y1anchor-20)*magic, (x1-220)*magic, (y1-20)*magic, (x2-220)*magic, (y2-20)*magic, 330, (y2anchor-20)*magic);
  
  alavanca();
  
  // Eixos
  
  textFont(verdana, 10);
  text(temp2, -30, 5.5f);
  text(temp1, -30, 396.5f);
  for (float i = 71; i < 377.5f; i += 65.5f) {
    text(temp2 - k*tempm, -30, i);
    k++;
  }
  k = 0;
  
  for (float i = 0; i < 332; i += 65.5f/2) {
    text(k*10, i, 418);
    k++;
  }
  
  text("Composi\u00e7\u00e3o de B(%p)", 155, 450);
  
  pushMatrix();
    resetMatrix();
    rotate(-HALF_PI);
    text("Temperatura (\u00baC)", -300, 40);
  popMatrix();
  
  k = 1;
  
  p[activePoint].display();
  p[activePoint].seta();
  
  // Botoes de modificar a curva e play da anima\u00e7\u00e3o de resfriamento
  
  image(b_mod0, 0, 425);
  if (mouseX > 100 && mouseX < 168 && mouseY > 525 && mouseY < 553 && activeScreen == 2)
    image(b_mod1, 0, 425);
  
  popMatrix();
  resetMatrix();
  
  // Mostra as informa\u00e7\u00f5es
  
  pushMatrix();
  
  translate(550, 300);
  
  image(b_play0, textWidth("Explica\u00e7\u00e3o:") + 10, 228);
  if (mouseX > textWidth("Explica\u00e7\u00e3o:") + 560 && mouseX < textWidth("Explica\u00e7\u00e3o:") + 589 && mouseY > 528 && mouseY < 551 && activeScreen == 2)
    image(b_play1, textWidth("Explica\u00e7\u00e3o:") + 10, 228);
  
  image(infobox, 0, -15);
  
  // Dados do diagrama
  
  p[activePoint].info();
  
  pushStyle();
  
  textFont(verdana, 10);
  textAlign(LEFT, BOTTOM);
  
  text("Explica\u00e7\u00e3o:", 0, 245);
  
  pushMatrix();
  resetMatrix();
  
  //translate(0, 15);
  translate(550, 319);
  
  switch(info_in) {
    case 0: text("      " + (nf(100 - p[activePoint].pc, 1, 1)) + " %", 15, 35);
            text("      " + nf(p[activePoint].pc, 1, 1) + " %", 15, 50);
            text("                     " + PApplet.parseInt(p[activePoint].pt) + " \u00baC", 15, 70);
            text("              " + (nf(100 - walpha*100, 1, 1)) + "%", 15, 125);
            text("             " + nf(walpha*100, 1, 1) + "%", 15, 140);
            break;
    case 1: text("      " + input + " %", 15, 35);
            text("      " + nf(p[activePoint].pc, 1, 1) + " %", 15, 50);
            text("                     " + PApplet.parseInt(p[activePoint].pt) + " \u00baC", 15, 70);
            text("              " + (nf(100 - walpha*100, 1, 1)) + "%", 15, 125);
            text("             " + nf(walpha*100, 1, 1) + "%", 15, 140);
            break;
    case 2: text("      " + (nf(100 - p[activePoint].pc, 1, 1)) + " %", 15, 35);
            text("      " + input + " %", 15, 50);
            text("                     " + PApplet.parseInt(p[activePoint].pt) + " \u00baC", 15, 70);
            text("              " + (nf(100 - walpha*100, 1, 1)) + "%", 15, 125);
            text("             " + nf(walpha*100, 1, 1) + "%", 15, 140);
            break;
    case 3: text("      " + (nf(100 - p[activePoint].pc, 1, 1)) + " %", 15, 35);
            text("      " + nf(p[activePoint].pc, 1, 1) + " %", 15, 50);
            text("                     " + input + " \u00baC", 15, 70);
            text("              " + (nf(100 - walpha*100, 1, 1)) + "%", 15, 125);
            text("             " + nf(walpha*100, 1, 1) + "%", 15, 140);
            break;
    case 4: text("      " + (nf(100 - p[activePoint].pc, 1, 1)) + " %", 15, 35);
            text("      " + nf(p[activePoint].pc, 1, 1) + " %", 15, 50);
            text("                     " + PApplet.parseInt(p[activePoint].pt) + " \u00baC", 15, 70);
            text("              " + nf(walpha*100, 1, 1) + "%", 15, 140);
            break;
    case 5: text("      " + (nf(100 - p[activePoint].pc, 1, 1)) + " %", 15, 35);
            text("      " + nf(p[activePoint].pc, 1, 1) + " %", 15, 50);
            text("                     " + PApplet.parseInt(p[activePoint].pt) + " \u00baC", 15, 70);
            text("              " + (nf(100 - walpha*100, 1, 1)) + "%", 15, 125);
            text("             " + PApplet.parseInt(input) + "%", 15, 140);
            break;
  }    
  
  
  // Caixas de sele\u00e7\u00e3o da info
  
  if (mouseX > 550 && mouseX < 721 && mouseY > 322.5f+15 && mouseY < 337.5f+15)
    image(info_s, 0, 22);
  if (mouseX > 550 && mouseX < 721 && mouseY > 337.5f+15 && mouseY < 352.5f+15)
    image(info_s, 0, 35);
  if (mouseX > 550 && mouseX < 721 && mouseY > 352.5f+20 && mouseY < 367.5f+20)
    image(info_s, 0, 57);
    
  if (state == 1)
    text("           L\u00edquido", 15, 85);
  if (state == 2) 
    text("           L\u00edquido + S\u00f3lido", 15, 85);
  if (state == 4)
    text("           S\u00f3lido", 15, 85); 
  
  if (mouseX > 550 && mouseX < 721 && mouseY > 430 && mouseY < 445)
    image(info_s, 0, 99+15-3);
  if (mouseX > 550 && mouseX < 721 && mouseY > 445 && mouseY < 460)
    image(info_s, 0, 114+15-4);
    
  text("             " + PApplet.parseInt(temp2 - (temp2 - temp1)*(y1anchor-20)*magic/397) + " \u00baC", 15, 165);
  textSize(8);
//    text("fus\u00e3o A", 22, 170);
//    text("fus\u00e3o B", 22, 185);
  textSize(10);
  text("             " + PApplet.parseInt(temp2 - (temp2 - temp1)*(y2anchor-20)*magic/397) + " \u00baC", 15, 180);
  
  
  popMatrix();
  popStyle();  
  
  popMatrix();
  resetMatrix();
  
  if (dropb == 1)
    drop();
  
  if (simulacao == 1)
    cooling();
  
  image(b_instruc0, 690, 10);
  if (mouseX > 690 && mouseX < 790 && mouseY > 10 && mouseY < 40)
    image(b_instruc1, 690, 10);
    
  image(b_ti0, 10, 10);
  if (mouseX > 10 && mouseX < 110 && mouseY > 10 && mouseY < 40)
    image(b_ti1, 10, 10);
  
  image(title, 102, 60);
  
  image(title_micro, 590, 50);
  
  println(mouseX);
  println(mouseY);
  
  Diagrama.endDraw();
  
  image(subtitles, 555, 225);
}

public void alavanca() {
  for (t = 0; t <= 1 && sq(y_bezier - p[activePoint].py) > EPS; t += 0.0001f) {
    y_bezier = bezierPoint((y1anchor-20)*magic, (y3-20)*magic, (y4-20)*magic, (y2anchor-20)*magic, t);
    x_bezier = bezierPoint(0, (x3-220)*magic, (x4-220)*magic, 330, t);
  }
    if (x_bezier >= p[activePoint].px && y_bezier >= p[activePoint].py)
      state = 1;
    else
      state = 2;
      
  for (t = 0; t <= 1 && sq(y_bezier2 - p[activePoint].py) > EPS; t += 0.0001f) {
    y_bezier2 = bezierPoint((y1anchor-20)*magic, (y1-20)*magic, (y2-20)*magic, (y2anchor-20)*magic, t);
    x_bezier2 = bezierPoint(0, (x1-220)*magic, (x2-220)*magic, 330, t);
  }
  
  if (state != 1) {
    if (x_bezier2 >= p[activePoint].px && y_bezier2 >= p[activePoint].py)
      state *= 1;
    else
      state *= 2;
  }
  
  if (state == 1) {
    wl = 1;
    walpha = 0;
  }
  
  if (state == 2) {
    s = x_bezier2 - p[activePoint].px;
    r = p[activePoint].px - x_bezier;
    
    wl = s/(r + s);
    walpha = 1 - wl;
  }
  if (state == 4) {
    wl = 0;
    walpha = 1;
  }
}

public void drawHelp() {
  drawDiagrama();
  
  pushStyle();
  
  image(scr_help, 0, 0);
  textFont(verdana, 10);
  fill(0);
  popStyle();
}


int imgposition = 27;
PImage fade;
PImage pactive;
PImage xp;

public void drop() {
  
  image(fade, 0, 0);
  
  pushMatrix();
  
  translate(550, 240);
  image(adrop, 0, 0);
  
  for(int pcount = 0; pcount < nPoint; pcount++) {
    image(adrop, 0, imgposition);
    imgposition += 27;
    text("Ponto " + (pcount + 1), 35, imgposition - 10);
    if (pcount != 0)
      image(xp, 110, imgposition - 18);
  }
  
  if (mouseX >= 550 && mouseX <= 721 && mouseY >= 267 && mouseY <= (267 + nPoint*27))
    image(pactive, 0, PApplet.parseInt((mouseY - 240)/27)*27);
  
  imgposition = 27;
  
  popMatrix();
}
PImage[] grain = new PImage[14];
PImage me_screen;
PImage me_mask;

public void grains() {
  
  pushMatrix();
  pushStyle();
  
  imageMode(CORNERS);  
  image(me_mask, 550, 0);
  
  if (state == 1)
    text("Liquido", 632, 150);
  
  imageMode(CENTER);
  
  // Essa parte aqui usei pra colocar cada gr\u00e3o na sua posi\u00e7\u00e3o certa, como um quebra-cabe\u00e7a
  // pra quando eles crescessem se encaixarem perfeitamente
  // 1. Tirar o "image(me_mask, 550, 0);" ali em cima
  // 2. Liberar as setas la no keyPressed()
  // 3. Trocar o me_screen la no setup
  
//  switch(cgrain) {
//    case 0: image(grain[0], mouseX, mouseY); break;
//    case 1: image(grain[1], mouseX, mouseY); break;
//    case 2: image(grain[2], mouseX, mouseY); break;
//    case 3: image(grain[3], mouseX, mouseY); break;
//    case 4: image(grain[4], mouseX, mouseY); break;
//    case 5: image(grain[5], mouseX, mouseY); break;
//    case 6: image(grain[6], mouseX, mouseY); break;
//    case 7: image(grain[7], mouseX, mouseY); break;
//    case 8: image(grain[8], mouseX, mouseY); break;
//    case 9: image(grain[9], mouseX, mouseY); break;
//    case 10: image(grain[10], mouseX, mouseY); break;
//    case 11: image(grain[11], mouseX, mouseY); break;
//    case 12: image(grain[12], mouseX, mouseY); break;
//    case 13: image(grain[13], mouseX, mouseY); break;
//  }
    image(grain[0], 600, 127, walpha*grain[0].width, walpha*grain[0].height);
    image(grain[1], 623, 160, walpha*grain[1].width, walpha*grain[1].height);
    
    image(grain[3], 654, 126, walpha*grain[3].width, walpha*grain[3].height);
    image(grain[2], 637, 104, walpha*grain[2].width, walpha*grain[2].height);
    
    image(grain[4], 683, 125, walpha*grain[4].width, walpha*grain[4].height);
    image(grain[5], 660, 163, walpha*grain[5].width, walpha*grain[5].height);
    image(grain[6], 679, 151, walpha*grain[6].width, walpha*grain[6].height);
    image(grain[7], 673, 184, walpha*grain[7].width, walpha*grain[7].height);
    image(grain[8], 642, 195, walpha*grain[8].width, walpha*grain[8].height);
    image(grain[9], 619, 202, walpha*grain[9].width, walpha*grain[9].height);
    
    image(grain[11], 574, 133, walpha*grain[11].width, walpha*grain[11].height);
    image(grain[10], 593, 176, walpha*grain[10].width, walpha*grain[10].height);
        
    image(grain[12], 605, 92, walpha*grain[12].width, walpha*grain[12].height);
    image(grain[13], 677, 101, walpha*grain[13].width, walpha*grain[13].height);
  
  imageMode(CORNERS);  
  image(me_screen, 550, 0);
  
  popStyle();
  popMatrix();
  
  println(mouseX);
  println(mouseY);
}
PImage inicio;
PImage b_ani0, b_ani1, b_ani2;
PImage b_dia0, b_dia1, b_dia2;
PImage b_help0, b_help1, b_help2;

PImage credits;

PImage b1, b2;

public void drawInicio() {
  
  Inicio.beginDraw(); // Nao precisava de um PGraphics, mas enfim
  background(backgnd);
  
   textAlign(CENTER);
   fill(0);
   image(inicio, 94, 150);
   
   image(b_ani0, 198, 300);
   image(b_dia0, 479, 300);
   image(b_help0, 670, 5);
   
   fill(100);
   textFont(calibri, 15);
   
   if (mouseX > 198 && mouseX < 324 && mouseY > 300 && mouseY < 337 && activeScreen == 0) {
     image(b_ani2, 198, 300);
     image(b1, 170, 340);
   }
     
   if (mouseX > 479 && mouseX < 605 && mouseY > 300 && mouseY < 337 && activeScreen == 0) {
     image(b_dia2, 479, 300);
     image(b2, 455, 340);
   }

   if (mouseX > 670 && mouseX < 795 && mouseY > 5 && mouseY < 41 && activeScreen == 0)
     image(b_help1, 670, 5);

   Inicio.endDraw();   
}

public void drawCredits() {
    
    drawInicio();
    
    fill(75);    
    image(credits, 0, 0);

}

int opcao = 1;
int y1anchor = 190;
int y2anchor = 70;
int x1 = 285, y1 = 155;
int x2 = 330, y2 = 130;
int x3 = 260, y3 = 110;
int x4 = 320, y4 = 85;
int a1 = 0, a2 = 0;
int k = 1;

String input = "";
int temp1 = 1000;
int temp2 = 1600;
int tempm = 100;
int temp_input = 0;

PImage b1_on, b1_off;
PImage t_ptoA, t_ptoB, t_liquidus, t_solidus;
PImage b_reset0, b_reset1, b_reset2;
PImage b_temp, b_temp_on;
PImage p_back;

PFont verdana;
public void drawPerfil() {  
  
  Perfil.beginDraw();
  
  pushStyle();
  
  drawDiagrama();
  image(p_back, 0, 0);
  
  textFont(verdana);
  textSize(12);
  
  stroke(255, 0, 0);
  noFill();

  pushMatrix();
  
  translate(195, 160);
  
  // Imagens
  
  image(p_curve, 220, 20);
  image(t_ptoA, 40, 52);
  image(t_ptoB, 40, 73);
  image(t_liquidus, 40, 93);
  image(t_solidus, 40, 113);
  
  image(b_temp, 187, 213);
  image(b_temp, 187, 14);
  
  if (temp_input == 1) 
    image(b_temp_on, 187, 213);
  if (temp_input == 2)
    image(b_temp_on, 187, 14);
    
  // Textos
  
  fill(0);
  text("A", 220, 235);
  text("B", 378, 235);
  
  textSize(8);
  
  if (temp_input == 0) {
    text(temp1, 202, 222);
    text(temp2, 202, 23);
  }
  else if (temp_input == 1) {
    text(input, 202, 222);
    text(temp2, 202, 23);
  }
  else if (temp_input == 2) {
    text(temp1, 202, 222);
    text(input, 202, 23);
  }

  for (int i = 56; i < 219; i += 33) {
    text(temp2 - k*tempm, 202, i);
    k++;
  }
  k = 1;
  textSize(12);
  noFill();
  
  // Botoes de controle
  
  if (opcao == 1) {
    image(b1_on, 20, 50);
    image(b1_off, 20, 70);
    image(b1_off, 20, 90);
    image(b1_off, 20, 110);
  }
  
  if (opcao == 2) {
    image(b1_off, 20, 50);
    image(b1_on, 20, 70);
    image(b1_off, 20, 90);
    image(b1_off, 20, 110);
  }
  
  if (opcao == 3) {
    image(b1_off, 20, 50);
    image(b1_off, 20, 70);
    image(b1_on, 20, 90);
    image(b1_off, 20, 110);
  }
  
  if (opcao == 4) {
    image(b1_off, 20, 50);
    image(b1_off, 20, 70);
    image(b1_off, 20, 90);
    image(b1_on, 20, 110);
  }
  
  image(b_reset0, 20, 150);
  if (mouseX > 215 && mouseX < 283 && mouseY > 310 && mouseY < 338)
    image(b_reset1, 20, 150);
  
  popMatrix();
  
  bezier(220+195, y1anchor+160, x3+195, y3+160, x4+195, y4+160, 385+195, y2anchor+160);
  bezier(220+195, y1anchor+160, x1+195, y1+160, x2+195, y2+160, 385+195, y2anchor+160);
  
  // Desenho das linhas guias
  
  stroke(0);
  
  if (a1 == 1) {
    line(220+195, y1anchor+160, mouseX, mouseY);
    ellipse(mouseX, mouseY, 3, 3);
  }
  
  if (a2 == 1) {
    line(385+195, y2anchor+160, mouseX, mouseY);
    ellipse(mouseX, mouseY, 3, 3);
  }
  
  stroke(255, 0, 0);
  
  popStyle();
  Perfil.endDraw();
  
  println(mouseX);
  println(mouseY);
}


class Pontos {
  float px;
  float py;
  float px_i;
  float py_i;
  
  float pc;
  float pt;
  
  Pontos(float temp_px, float temp_py, float temp_px_i, float temp_py_i) {
    px = temp_px;
    py = temp_py;
    px_i = temp_px_i;
    py_i = temp_py_i;
  }
  
  public void display() {
    stroke(0);
    fill(0);
    ellipse(px, py, 2, 2);
  }
  
  public void info() {
    pc = (px)*100/331;
    pt = temp2 - (temp2 - temp1)*py/397;
  }
  
  public void seta() {
    image(setac, px - 6, 400);
    image(setad, -10, py - 6);
  }
}
float py_temp;
PImage text1;
PImage text2;
PImage text3;
PImage text4;
PImage text5;
PImage box15;

PImage goon0, goon1;

int iframe = 0;

public void cooling() {
  pushMatrix();
  translate(100, 100);
  
  if (p[activePoint].py <= 397) {
    
    if (p[activePoint].py == 0 && iframe == 1) {
      image(text1, p[activePoint].px + 5, p[activePoint].py + 5);
      
      // Posicionamento do bot\u00e3o pra continuar 1
      
      if (mouseX >= p[activePoint].px + text1.width - goon0.width + 223 && mouseX <= p[activePoint].px + text1.width + 100 && mouseY >= p[activePoint].py + text1.height - goon0.height + 100 && mouseY <= p[activePoint].py + text1.height + 100)
        image(goon1, p[activePoint].px + text1.width - goon1.width, p[activePoint].py + text1.height - goon1.height);
      else
        image(goon0, p[activePoint].px + text1.width - goon0.width, p[activePoint].py + text1.height - goon0.height);
    }
    
    if (state == 1 && (iframe == 2 || iframe == 4)) 
      p[activePoint].py += 0.5f;
      
        if (sq(p[activePoint].py - 0.5f*y_bezier) <= EPS*10)
          iframe = 3;
        if (iframe == 3) {
          image(text2, p[activePoint].px + 5, p[activePoint].py + 5);
          
          // Posicionamento do bot\u00e3o pra continuar 2
                    
          if (mouseX >= p[activePoint].px + text2.width - goon0.width + 223 && mouseX <= p[activePoint].px + text2.width + 100 && mouseY >= p[activePoint].py + text2.height - goon0.height + 100 && mouseY <= p[activePoint].py + text2.height + 100)
            image(goon1, p[activePoint].px + text2.width - goon1.width, p[activePoint].py + text2.height - goon1.height);
          else
            image(goon0, p[activePoint].px + text2.width - goon0.width, p[activePoint].py + text2.height - goon0.height);
        }
          
    if (state == 2 && iframe == 4) {
      image(box15, 450, 330, 171, 28);
      image(text3, p[activePoint].px + 5, p[activePoint].py + 5);
      
          // Posicionamento do bot\u00e3o pra continuar 3
                    
          if (mouseX >= p[activePoint].px + text3.width - goon0.width + 223 && mouseX <= p[activePoint].px + text3.width + 100 && mouseY >= p[activePoint].py + text3.height - goon0.height + 100 && mouseY <= p[activePoint].py + text3.height + 100)
            image(goon1, p[activePoint].px + text3.width - goon1.width, p[activePoint].py + text3.height - goon1.height);
          else
            image(goon0, p[activePoint].px + text3.width - goon0.width, p[activePoint].py + text3.height - goon0.height);      
      
    }
      
      if (state == 2) {
        pushStyle();
        
        strokeWeight(0.5f);
        
        //line(x_bezier, p[activePoint].py, x_bezier2, p[activePoint].py);

        if (iframe == 5 || iframe == 7)
          p[activePoint].py += 0.4f;
          
        if (wl >= 0.5f - EPS && wl <= 0.5f + EPS && iframe != 7)
          iframe = 6;     
        if (iframe == 6) {
          image(text4, p[activePoint].px + 5, p[activePoint].py + 5);
          
          // Posicionamento do bot\u00e3o pra continuar 4
                    
          if (mouseX >= p[activePoint].px + text4.width - goon0.width + 223 && mouseX <= p[activePoint].px + text4.width + 100 && mouseY >= p[activePoint].py + text4.height - goon0.height + 100 && mouseY <= p[activePoint].py + text4.height + 100)
            image(goon1, p[activePoint].px + text4.width - goon1.width, p[activePoint].py + text4.height - goon1.height);
          else
            image(goon0, p[activePoint].px + text4.width - goon0.width, p[activePoint].py + text4.height - goon0.height);          
          
        }
          
        popStyle();
      }
        
      if (state == 4) {
        if (iframe == 7) {
          image(text5, p[activePoint].px + 5, p[activePoint].py + 5);
          
          // Posicionamento do bot\u00e3o pra continuar 5
                    
          if (mouseX >= p[activePoint].px + text5.width - goon0.width + 223 && mouseX <= p[activePoint].px + text5.width + 100 && mouseY >= p[activePoint].py + text5.height - goon0.height + 100 && mouseY <= p[activePoint].py + text5.height + 100)
            image(goon1, p[activePoint].px + text5.width - goon1.width, p[activePoint].py + text5.height - goon1.height);
          else
            image(goon0, p[activePoint].px + text5.width - goon0.width, p[activePoint].py + text5.height - goon0.height);          
          
        }
        if (iframe == 8)
          p[activePoint].py += 0.8f;
      }
  }
  
  if (p[activePoint].py > 397) {
    p[activePoint].py = py_temp;
    simulacao = 0;
    iframe = 0;
  }
  
  popMatrix();
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "Analise_Termica" });
  }
}
