PImage title;

PImage diagrama;
PImage infobox;
PImage info_s;

PImage drop;
PImage plus;
PImage adrop;
PImage sdrop;
PImage aplus;
PImage splus;

PImage setad;
PImage setac;

PImage b_mod0;
PImage b_mod1;
PImage b_mod2;

PImage b_play0;
PImage b_play1;
PImage b_play2;

PImage b_instruc0;
PImage b_instruc1;
PImage b_instruc2;

PImage b_ti0;
PImage b_ti1;
PImage b_ti2;

int dropb = 0;
int lock_axis;
float x_bezier, y_bezier;
float x_bezier2, y_bezier2;

int simulacao = 0;

PImage scr_help;

// 1: %A , 2: %B , 3: T , 4: Wl , 5: Walpha

int info_in = 0;

// Variaveis dos pontos

int activePoint = -1;
int nPoint = 1;
Pontos[] p = new Pontos[5];
float r, s;
float wl, walpha;

float t;
float EPS = 0.01;

// 1: liquido, 2: solido + liquido, 4: solido

int state = 0;

float magic = 1.993975903;

PImage title_micro;

void drawDiagrama() {
  
  Diagrama.beginDraw();
  
  background(backgnd);
  image(diagrama, 100, 100);

  grains();
  
  // Redesenha a o diagrama numa proporção maior. A proporcao
  // (magic) eu achei dividindo as dimensoes do diagrama maior
  // pelas do menor
  
  pushMatrix();
  
  noFill();
  stroke(255, 0, 0);
  translate(100, 100);
  
  // Condicao inicial
  
  if (activePoint == -1) {
    p[0] = new Pontos(0, 100, 0, 0); // 397
    activePoint = 0;
  }
  
  bezier(0, (y1anchor-20)*magic, (x3-220)*magic, (y3-20)*magic, (x4-220)*magic, (y4-20)*magic, 330, (y2anchor-20)*magic);
  bezier(0, (y1anchor-20)*magic, (x1-220)*magic, (y1-20)*magic, (x2-220)*magic, (y2-20)*magic, 330, (y2anchor-20)*magic);
  
  alavanca();
  
  // Eixos
  
  textFont(verdana, 10);
  text(temp2, -30, 5.5);
  text(temp1, -30, 396.5);
  for (float i = 71; i < 377.5; i += 65.5) {
    text(temp2 - k*tempm, -30, i);
    k++;
  }
  k = 0;
  
  for (float i = 0; i < 332; i += 65.5/2) {
    text(k*10, i, 418);
    k++;
  }
  
  text("Composição de B(%p)", 155, 450);
  
  pushMatrix();
    resetMatrix();
    rotate(-HALF_PI);
    text("Temperatura (ºC)", -300, 40);
  popMatrix();
  
  k = 1;
  
  p[activePoint].display();
  p[activePoint].seta();
  
  // Botoes de modificar a curva e play da animação de resfriamento
  
  image(b_mod0, 0, 425);
  if (mouseX > 100 && mouseX < 168 && mouseY > 525 && mouseY < 553 && activeScreen == 2)
    image(b_mod1, 0, 425);
  
  popMatrix();
  resetMatrix();
  
  // Mostra as informações
  
  pushMatrix();
  
  translate(550, 300);
  
  image(b_play0, textWidth("Explicação:") + 10, 228);
  if (mouseX > textWidth("Explicação:") + 560 && mouseX < textWidth("Explicação:") + 589 && mouseY > 528 && mouseY < 551 && activeScreen == 2)
    image(b_play1, textWidth("Explicação:") + 10, 228);
  
  image(infobox, 0, -15);
  
  // Dados do diagrama
  
  p[activePoint].info();
  
  pushStyle();
  
  textFont(verdana, 10);
  textAlign(LEFT, BOTTOM);
  
  text("Explicação:", 0, 245);
  
  pushMatrix();
  resetMatrix();
  
  //translate(0, 15);
  translate(550, 319);
  
  switch(info_in) {
    case 0: text("      " + (nf(100 - p[activePoint].pc, 1, 1)) + " %", 15, 35);
            text("      " + nf(p[activePoint].pc, 1, 1) + " %", 15, 50);
            text("                     " + int(p[activePoint].pt) + " ºC", 15, 70);
            text("              " + (nf(100 - walpha*100, 1, 1)) + "%", 15, 125);
            text("             " + nf(walpha*100, 1, 1) + "%", 15, 140);
            break;
    case 1: text("      " + input + " %", 15, 35);
            text("      " + nf(p[activePoint].pc, 1, 1) + " %", 15, 50);
            text("                     " + int(p[activePoint].pt) + " ºC", 15, 70);
            text("              " + (nf(100 - walpha*100, 1, 1)) + "%", 15, 125);
            text("             " + nf(walpha*100, 1, 1) + "%", 15, 140);
            break;
    case 2: text("      " + (nf(100 - p[activePoint].pc, 1, 1)) + " %", 15, 35);
            text("      " + input + " %", 15, 50);
            text("                     " + int(p[activePoint].pt) + " ºC", 15, 70);
            text("              " + (nf(100 - walpha*100, 1, 1)) + "%", 15, 125);
            text("             " + nf(walpha*100, 1, 1) + "%", 15, 140);
            break;
    case 3: text("      " + (nf(100 - p[activePoint].pc, 1, 1)) + " %", 15, 35);
            text("      " + nf(p[activePoint].pc, 1, 1) + " %", 15, 50);
            text("                     " + input + " ºC", 15, 70);
            text("              " + (nf(100 - walpha*100, 1, 1)) + "%", 15, 125);
            text("             " + nf(walpha*100, 1, 1) + "%", 15, 140);
            break;
    case 4: text("      " + (nf(100 - p[activePoint].pc, 1, 1)) + " %", 15, 35);
            text("      " + nf(p[activePoint].pc, 1, 1) + " %", 15, 50);
            text("                     " + int(p[activePoint].pt) + " ºC", 15, 70);
            text("              " + nf(walpha*100, 1, 1) + "%", 15, 140);
            break;
    case 5: text("      " + (nf(100 - p[activePoint].pc, 1, 1)) + " %", 15, 35);
            text("      " + nf(p[activePoint].pc, 1, 1) + " %", 15, 50);
            text("                     " + int(p[activePoint].pt) + " ºC", 15, 70);
            text("              " + (nf(100 - walpha*100, 1, 1)) + "%", 15, 125);
            text("             " + int(input) + "%", 15, 140);
            break;
  }    
  
  
  // Caixas de seleção da info
  
  if (mouseX > 550 && mouseX < 721 && mouseY > 322.5+15 && mouseY < 337.5+15)
    image(info_s, 0, 22);
  if (mouseX > 550 && mouseX < 721 && mouseY > 337.5+15 && mouseY < 352.5+15)
    image(info_s, 0, 35);
  if (mouseX > 550 && mouseX < 721 && mouseY > 352.5+20 && mouseY < 367.5+20)
    image(info_s, 0, 57);
    
  if (state == 1)
    text("           Líquido", 15, 85);
  if (state == 2) 
    text("           Líquido + Sólido", 15, 85);
  if (state == 4)
    text("           Sólido", 15, 85); 
  
  if (mouseX > 550 && mouseX < 721 && mouseY > 430 && mouseY < 445)
    image(info_s, 0, 99+15-3);
  if (mouseX > 550 && mouseX < 721 && mouseY > 445 && mouseY < 460)
    image(info_s, 0, 114+15-4);
    
  text("             " + int(temp2 - (temp2 - temp1)*(y1anchor-20)*magic/397) + " ºC", 15, 165);
  textSize(8);
//    text("fusão A", 22, 170);
//    text("fusão B", 22, 185);
  textSize(10);
  text("             " + int(temp2 - (temp2 - temp1)*(y2anchor-20)*magic/397) + " ºC", 15, 180);
  
  
  popMatrix();
  popStyle();  
  
  popMatrix();
  resetMatrix();
  
  if (dropb == 1)
    drop();
  
  if (simulacao == 1)
    cooling();
  
  image(b_instruc0, 690, 10);
  if (mouseX > 690 && mouseX < 790 && mouseY > 10 && mouseY < 40)
    image(b_instruc1, 690, 10);
    
  image(b_ti0, 10, 10);
  if (mouseX > 10 && mouseX < 110 && mouseY > 10 && mouseY < 40)
    image(b_ti1, 10, 10);
  
  image(title, 102, 60);
  
  image(title_micro, 590, 50);
  
  println(mouseX);
  println(mouseY);
  
  Diagrama.endDraw();
  
  image(subtitles, 555, 225);
}

void alavanca() {
  for (t = 0; t <= 1 && sq(y_bezier - p[activePoint].py) > EPS; t += 0.0001) {
    y_bezier = bezierPoint((y1anchor-20)*magic, (y3-20)*magic, (y4-20)*magic, (y2anchor-20)*magic, t);
    x_bezier = bezierPoint(0, (x3-220)*magic, (x4-220)*magic, 330, t);
  }
    if (x_bezier >= p[activePoint].px && y_bezier >= p[activePoint].py)
      state = 1;
    else
      state = 2;
      
  for (t = 0; t <= 1 && sq(y_bezier2 - p[activePoint].py) > EPS; t += 0.0001) {
    y_bezier2 = bezierPoint((y1anchor-20)*magic, (y1-20)*magic, (y2-20)*magic, (y2anchor-20)*magic, t);
    x_bezier2 = bezierPoint(0, (x1-220)*magic, (x2-220)*magic, 330, t);
  }
  
  if (state != 1) {
    if (x_bezier2 >= p[activePoint].px && y_bezier2 >= p[activePoint].py)
      state *= 1;
    else
      state *= 2;
  }
  
  if (state == 1) {
    wl = 1;
    walpha = 0;
  }
  
  if (state == 2) {
    s = x_bezier2 - p[activePoint].px;
    r = p[activePoint].px - x_bezier;
    
    wl = s/(r + s);
    walpha = 1 - wl;
  }
  if (state == 4) {
    wl = 0;
    walpha = 1;
  }
}

void drawHelp() {
  drawDiagrama();
  
  pushStyle();
  
  image(scr_help, 0, 0);
  textFont(verdana, 10);
  fill(0);
  popStyle();
}


